Index: LMDZ6/branches/Amaury_dev/libf/phylmd/hbtm_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/hbtm_mod.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/hbtm_mod.F90	(revision 5143)
@@ -589,37 +581,37 @@
     ! ********************************************************************
     DO i = 1, knon
-       check(i) = .TRUE.
-       zsat(i) = .FALSE.
-       ! omegafl utilise pour prolongement CAPE
-       omegafl(i) = .FALSE.
-       cape(i) = 0.
-       kape(i) = 0.
-       eauliq(i) = 0.
-       ctei(i) = 0.
-       pblk(i) = 0.0
-       fak1(i) = ustar(i)*pblh(i)*vk
-
-       ! Do additional preparation for unstable cases only, set temperature
-       ! and moisture perturbations depending on stability.
-       ! *** Rq: les formule sont prises dans leur forme CS ***
-       IF (unstbl(i)) THEN
-          ! AM Niveau de ref du thermique
-          ! AM          zxt=(t(i,1)-z(i,1)*0.5*RG/RCPD/(1.+RVTMP2*q(i,1)))
-          ! AM     .         *(1.+RETV*q(i,1))
-          zxt = (th_th(i)-zref*0.5*rg/rcpd/(1.+rvtmp2*qt_th(i)))* &
-               (1.+retv*qt_th(i))
-          phiminv(i) = (1.-binm*pblh(i)*unsobklen(i))**onet
-          phihinv(i) = sqrt(1.-binh*pblh(i)*unsobklen(i))
-          wm(i) = ustar(i)*phiminv(i)
-          fak2(i) = wm(i)*pblh(i)*vk
-          wstar(i) = (heatv(i)*rg*pblh(i)/zxt)**onet
-          fak3(i) = fakn*wstar(i)/wm(i)
-       ELSE
-          wstar(i) = 0.
-       END IF
-       ! Computes Theta_e for thermal (all cases : to be modified)
-       ! attention ajout therm(i) = virtuelle
-       the_th(i) = th_th(i) + therm(i) + rlvcp*qt_th(i)
-       ! ou:    The_th(i) = Th_th(i) + sqrt(b1)*khfs(i)/wm(i) + RLvCp*qT_th(i)
+      check(i) = .TRUE.
+      zsat(i) = .FALSE.
+      ! omegafl utilise pour prolongement CAPE
+      omegafl(i) = .FALSE.
+      cape(i) = 0.
+      kape(i) = 0.
+      eauliq(i) = 0.
+      ctei(i) = 0.
+      pblk(i) = 0.0
+      fak1(i) = ustar(i) * pblh(i) * vk
+
+      ! Do additional preparation for unstable cases only, set temperature
+      ! and moisture perturbations depending on stability.
+      ! *** Rq: les formule sont prises dans leur forme CS ***
+      IF (unstbl(i)) THEN
+        ! AM Niveau de ref du thermique
+        ! AM          zxt=(t(i,1)-z(i,1)*0.5*RG/RCPD/(1.+RVTMP2*q(i,1)))
+        ! AM     .         *(1.+RETV*q(i,1))
+        zxt = (th_th(i) - zref * 0.5 * rg / rcpd / (1. + rvtmp2 * qt_th(i))) * &
+                (1. + retv * qt_th(i))
+        phiminv(i) = (1. - binm * pblh(i) * unsobklen(i))**onet
+        phihinv(i) = sqrt(1. - binh * pblh(i) * unsobklen(i))
+        wm(i) = ustar(i) * phiminv(i)
+        fak2(i) = wm(i) * pblh(i) * vk
+        wstar(i) = (heatv(i) * rg * pblh(i) / zxt)**onet
+        fak3(i) = fakn * wstar(i) / wm(i)
+      ELSE
+        wstar(i) = 0.
+      END IF
+      ! Computes Theta_e for thermal (all cases : to be modified)
+      ! attention ajout therm(i) = virtuelle
+      the_th(i) = th_th(i) + therm(i) + rlvcp * qt_th(i)
+      ! ou:    The_th(i) = Th_th(i) + sqrt(b1)*khfs(i)/wm(i) + RLvCp*qT_th(i)
     END DO
 
@@ -629,137 +621,137 @@
     DO k = 2, isommet
 
-       ! Find levels within boundary layer:
-
-       DO i = 1, knon
-          unslev(i) = .FALSE.
-          stblev(i) = .FALSE.
-          zm(i) = z(i, k-1)
-          zp(i) = z(i, k)
-          IF (zkmin==0.0 .AND. zp(i)>pblh(i)) zp(i) = pblh(i)
-          IF (zm(i)<pblh(i)) THEN
-             zmzp = 0.5*(zm(i)+zp(i))
-             ! debug
-             ! if (i.EQ.1864) THEN
-             ! PRINT*,'i,pblh(1864),obklen(1864)',i,pblh(i),obklen(i)
-             ! END IF
-
-             zh(i) = zmzp/pblh(i)
-             zl(i) = zmzp*unsobklen(i)
-             zzh(i) = 0.
-             IF (zh(i)<=1.0) zzh(i) = (1.-zh(i))**2
-
-             ! stblev for points zm < plbh and stable and neutral
-             ! unslev for points zm < plbh and unstable
-
-             IF (unstbl(i)) THEN
-                unslev(i) = .TRUE.
-             ELSE
-                stblev(i) = .TRUE.
-             END IF
+      ! Find levels within boundary layer:
+
+      DO i = 1, knon
+        unslev(i) = .FALSE.
+        stblev(i) = .FALSE.
+        zm(i) = z(i, k - 1)
+        zp(i) = z(i, k)
+        IF (zkmin==0.0 .AND. zp(i)>pblh(i)) zp(i) = pblh(i)
+        IF (zm(i)<pblh(i)) THEN
+          zmzp = 0.5 * (zm(i) + zp(i))
+          ! debug
+          ! if (i.EQ.1864) THEN
+          ! PRINT*,'i,pblh(1864),obklen(1864)',i,pblh(i),obklen(i)
+          ! END IF
+
+          zh(i) = zmzp / pblh(i)
+          zl(i) = zmzp * unsobklen(i)
+          zzh(i) = 0.
+          IF (zh(i)<=1.0) zzh(i) = (1. - zh(i))**2
+
+          ! stblev for points zm < plbh and stable and neutral
+          ! unslev for points zm < plbh and unstable
+
+          IF (unstbl(i)) THEN
+            unslev(i) = .TRUE.
+          ELSE
+            stblev(i) = .TRUE.
           END IF
-       END DO
-       ! PRINT*,'fin calcul niveaux'
-
-       ! Stable and neutral points; set diffusivities; counter-gradient
-       ! terms zero for stable case:
-
-       DO i = 1, knon
-          IF (stblev(i)) THEN
-             IF (zl(i)<=1.) THEN
-                pblk(i) = fak1(i)*zh(i)*zzh(i)/(1.+betas*zl(i))
-             ELSE
-                pblk(i) = fak1(i)*zh(i)*zzh(i)/(betas+zl(i))
-             END IF
-             ! pcfm(i,k) = pblk(i)
-             ! pcfh(i,k) = pcfm(i,k)
+        END IF
+      END DO
+      ! PRINT*,'fin calcul niveaux'
+
+      ! Stable and neutral points; set diffusivities; counter-gradient
+      ! terms zero for stable case:
+
+      DO i = 1, knon
+        IF (stblev(i)) THEN
+          IF (zl(i)<=1.) THEN
+            pblk(i) = fak1(i) * zh(i) * zzh(i) / (1. + betas * zl(i))
+          ELSE
+            pblk(i) = fak1(i) * zh(i) * zzh(i) / (betas + zl(i))
           END IF
-       END DO
-
-       ! unssrf, unstable within surface layer of pbl
-       ! unsout, unstable within outer   layer of pbl
-
-       DO i = 1, knon
-          unssrf(i) = .FALSE.
-          unsout(i) = .FALSE.
-          IF (unslev(i)) THEN
-             IF (zh(i)<sffrac) THEN
-                unssrf(i) = .TRUE.
-             ELSE
-                unsout(i) = .TRUE.
-             END IF
+          ! pcfm(i,k) = pblk(i)
+          ! pcfh(i,k) = pcfm(i,k)
+        END IF
+      END DO
+
+      ! unssrf, unstable within surface layer of pbl
+      ! unsout, unstable within outer   layer of pbl
+
+      DO i = 1, knon
+        unssrf(i) = .FALSE.
+        unsout(i) = .FALSE.
+        IF (unslev(i)) THEN
+          IF (zh(i)<sffrac) THEN
+            unssrf(i) = .TRUE.
+          ELSE
+            unsout(i) = .TRUE.
           END IF
-       END DO
-
-       ! Unstable for surface layer; counter-gradient terms zero
-
-       DO i = 1, knon
-          IF (unssrf(i)) THEN
-             term = (1.-betam*zl(i))**onet
-             pblk(i) = fak1(i)*zh(i)*zzh(i)*term
-             pr(i) = term/sqrt(1.-betah*zl(i))
+        END IF
+      END DO
+
+      ! Unstable for surface layer; counter-gradient terms zero
+
+      DO i = 1, knon
+        IF (unssrf(i)) THEN
+          term = (1. - betam * zl(i))**onet
+          pblk(i) = fak1(i) * zh(i) * zzh(i) * term
+          pr(i) = term / sqrt(1. - betah * zl(i))
+        END IF
+      END DO
+      ! PRINT*,'fin counter-gradient terms zero'
+
+      ! Unstable for outer layer; counter-gradient terms non-zero:
+
+      DO i = 1, knon
+        IF (unsout(i)) THEN
+          pblk(i) = fak2(i) * zh(i) * zzh(i)
+          ! cgs(i,k) = fak3(i)/(pblh(i)*wm(i))
+          ! cgh(i,k) = khfs(i)*cgs(i,k)
+          pr(i) = phiminv(i) / phihinv(i) + ccon * fak3(i) / fak
+          ! cgq(i,k) = kqfs(i)*cgs(i,k)
+        END IF
+      END DO
+      ! PRINT*,'fin counter-gradient terms non zero'
+
+      ! For all unstable layers, compute diffusivities and ctrgrad ter m
+
+      ! DO i = 1, knon
+      ! IF (unslev(i)) THEN
+      ! pcfm(i,k) = pblk(i)
+      ! pcfh(i,k) = pblk(i)/pr(i)
+      ! etc cf original
+      ! ENDIF
+      ! ENDDO
+
+      ! For all layers, compute integral info and CTEI
+
+      DO i = 1, knon
+        IF (check(i) .OR. omegafl(i)) THEN
+          IF (.NOT. zsat(i)) THEN
+            ! Th2 = The_th(i) - RLvCp*qT_th(i)
+            th2 = th_th(i)
+            t2 = th2 * s(i, k)
+            ! thermodyn functions
+            zdelta = max(0., sign(1., rtt - t2))
+            qqsat = r2es * foeew(t2, zdelta) / pplay(i, k)
+            qqsat = min(0.5, qqsat)
+            zcor = 1. / (1. - retv * qqsat)
+            qqsat = qqsat * zcor
+
+            IF (qqsat<qt_th(i)) THEN
+              ! on calcule lcl
+              IF (k==2) THEN
+                plcl(i) = z(i, k)
+              ELSE
+                plcl(i) = z(i, k - 1) + (z(i, k - 1) - z(i, k)) * (qt_th(i)&
+                        - qsatbef(i)) / (qsatbef(i) - qqsat)
+              END IF
+              zsat(i) = .TRUE.
+              tbef(i) = t2
+            END IF
+
+            qsatbef(i) = qqsat ! bug dans la version orig ???
           END IF
-       END DO
-       ! PRINT*,'fin counter-gradient terms zero'
-
-       ! Unstable for outer layer; counter-gradient terms non-zero:
-
-       DO i = 1, knon
-          IF (unsout(i)) THEN
-             pblk(i) = fak2(i)*zh(i)*zzh(i)
-             ! cgs(i,k) = fak3(i)/(pblh(i)*wm(i))
-             ! cgh(i,k) = khfs(i)*cgs(i,k)
-             pr(i) = phiminv(i)/phihinv(i) + ccon*fak3(i)/fak
-             ! cgq(i,k) = kqfs(i)*cgs(i,k)
-          END IF
-       END DO
-       ! PRINT*,'fin counter-gradient terms non zero'
-
-       ! For all unstable layers, compute diffusivities and ctrgrad ter m
-
-       ! DO i = 1, knon
-       ! IF (unslev(i)) THEN
-       ! pcfm(i,k) = pblk(i)
-       ! pcfh(i,k) = pblk(i)/pr(i)
-       ! etc cf original
-       ! ENDIF
-       ! ENDDO
-
-       ! For all layers, compute integral info and CTEI
-
-       DO i = 1, knon
-          IF (check(i) .OR. omegafl(i)) THEN
-             IF (.NOT. zsat(i)) THEN
-                ! Th2 = The_th(i) - RLvCp*qT_th(i)
-                th2 = th_th(i)
-                t2 = th2*s(i, k)
-                ! thermodyn functions
-                zdelta = max(0., sign(1.,rtt-t2))
-                qqsat = r2es*foeew(t2, zdelta)/pplay(i, k)
-                qqsat = min(0.5, qqsat)
-                zcor = 1./(1.-retv*qqsat)
-                qqsat = qqsat*zcor
-
-                IF (qqsat<qt_th(i)) THEN
-                   ! on calcule lcl
-                   IF (k==2) THEN
-                      plcl(i) = z(i, k)
-                   ELSE
-                      plcl(i) = z(i, k-1) + (z(i,k-1)-z(i,k))*(qt_th(i)&
-                           -qsatbef(i))/(qsatbef(i)-qqsat)
-                   END IF
-                   zsat(i) = .TRUE.
-                   tbef(i) = t2
-                END IF
-
-                qsatbef(i) = qqsat ! bug dans la version orig ???
-             END IF
-             ! amn ???? cette ligne a deja ete faite normalement ?
-          END IF
-          ! PRINT*,'hbtm2 i,k=',i,k
-       END DO
+          ! amn ???? cette ligne a deja ete faite normalement ?
+        END IF
+        ! PRINT*,'hbtm2 i,k=',i,k
+      END DO
     END DO ! end of level loop
     ! IM 170305 BEG
     IF (1==0) THEN
-       PRINT *, 'hbtm2  ok'
+      PRINT *, 'hbtm2  ok'
     END IF !(1.EQ.0) THEN
     ! IM 170305 END
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/hines_gwd.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/hines_gwd.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/hines_gwd.F90	(revision 5143)
@@ -14,7 +14,9 @@
 
   USE dimphy
+  USE lmdz_YOEGWD, ONLY: GFRCRIT, GKWAKE, GRCRIT, GVCRIT, GKDRAG, GKLIFT, GHMAX, GRAHILO, GSIGCR, NKTOPG, NSTRA, GSSEC, GTSEC, GVSEC, &
+          GWD_RANDO_RUWMAX, gwd_rando_sat, GWD_FRONT_RUWMAX, gwd_front_sat
+
   IMPLICIT NONE
 
-  include "YOEGWD.h"
   include "YOMCST.h"
 
